import pandas
import numpy as np
import sys
from sklearn import model_selection
from sklearn.linear_model import LogisticRegression
import joblib


def main(argv):
	narg = len(argv)
	if narg<4:
		print("num of arg is not proper, exiting")
		exit(1)
	model_name = argv[1]
	input_op = argv[2]
	if input_op == "1" and narg < 5:
		print("for input as file, we need out put file name as well, less num of arg supplied")
		return "ERROR_ARGS"

	loaded_model = joblib.load(model_name)
	try:
		if input_op == "2":
			input_list = [float(i) for i in argv[3].split(',')]
			input_list = np.array(input_list).reshape(1, -1)
			result = loaded_model.predict(input_list)
			#np.savetxt(sys.stdout, result, fmt="%2.3f")
			print(result.item(0))
			return '%.2f' % result.item(0)
		elif input_op == "1":
			fname = argv[3]
			out_fname = argv[4]
			of = open(out_fname, "w")
			lines = [line.rstrip('\n') for line in open(fname)]
			for line in lines:
				line = [float(i) for i in line.split(',')]
				line = line[:15]
				line = np.array(line).reshape(1, -1)
				result = loaded_model.predict(line)
				np.savetxt(of, result, fmt="%2.3f")
			of.close()
			return "SUCCESS"
	except Exception as e:
		print("error in execution", e)
	return "ERROR"


if __name__ == "__main__":
	try:
		if len(sys.argv) < 4:
			print("Usage: python3 logistic_pred.py <model_name> <input type[1,2], 1 for file 2 \
			for event/line> <input [line or file]> <out_file[optional for option 2 only]>")
			exit(1)
		main(sys.argv[0:])
	except KeyboardInterrupt:
		print("Interrupt Received.. Shutting Down..")
		exit(1)
