# Save Model Using joblib
import pandas as pd
import sys
import joblib
import numpy as np 
import keras
from keras.models import Sequential
from keras.layers import Dense


def main(argv):
	narg = len(argv)
	if narg<3:
		print("argument list is improper")
		exit(1)
	model_name = argv[1]
	train_data = argv[2]
	try:
		dataset = pd.read_csv(train_data)
		x = dataset.iloc[:,1:16]
		y = dataset.iloc[:,0]
		classifier = Sequential()
		classifier.add(Dense(output_dim = 6, init = 'uniform', activation = 'relu', input_dim = 15))
		classifier.add(Dense(output_dim = 6, init = 'uniform', activation = 'relu'))
		classifier.add(Dense(output_dim = 1, init = 'uniform', activation = 'sigmoid'))
		classifier.compile(optimizer = 'adam', loss = 'binary_crossentropy', metrics = ['accuracy'])
		classifier.fit(x, y, batch_size = 10, nb_epoch = 2)
		print("model trained")
		# save the model to disk
		joblib.dump(classifier, model_name)
		print("model [ ", model_name, " ] saved to disk")
		return "SUCCESS"
	except Exception as e:
		print("error in execution", e)
	return "ERROR"


if __name__ == "__main__":
	try:
		if len(sys.argv) < 3:
			print ("Usage: python3 weather_train.py <model_name_path> <data_for_training> <list_of_columns [ optional ]>")
			exit (1)
		main(sys.argv[0:])
	except KeyboardInterrupt:
		print("Interrupt Received.. Shutting Down..")
		exit(1)
